package com.example.timer.util;

import com.example.timer.info.Timerinfo;
import org.quartz.*;

import java.util.Date;

public final class timeutil {
    private timeutil() {}


    public static JobDetail buildJobDetail(final Class jobclass, final Timerinfo info) {
        final JobDataMap jobDataMap = new JobDataMap();
        jobDataMap.put(jobclass.getSimpleName(),info);


        return JobBuilder
                .newJob(jobclass)
                .withIdentity(jobclass.getSimpleName())
                .setJobData(jobDataMap)
                .build();
    }

    public static Trigger buildTrigger(final Class jobClass,final Timerinfo info) {
        SimpleScheduleBuilder builder = SimpleScheduleBuilder.simpleSchedule().withIntervalInMilliseconds( info.getRepeatIntervalMs());

        if (info.isRunForever()) {
            builder = builder.repeatForever();
        } else {
            builder = builder.withRepeatCount(info.getTotalFireCount() - 1);
        }
        return TriggerBuilder
                .newTrigger()
                .withIdentity(jobClass.getSimpleName())
                .withSchedule(builder)
                .startAt(new Date(System.currentTimeMillis() + info.getInitialOffsetMs()))
                .build();
    }
    }


